## 4.4.0.0
+ added: RelatedBlock class
+ added: CommonCollect class
+ added: MeterIndicators class
+ added: methods to ForgeCreativeTab class for proper setting tab icon
+ added: toBlockPos method to Vect3d class
* improved: UnitsInit and UnitsInitWithEnum classes
* changed: behavior of UnitId.from(Enum) method
* fixed: configs being not properly saved for units initialized from enums
* fixed: RenderItemHook injection before model rendering
* __note: update all related mods to the latest versions__

## 4.3.21.0
+ added: method sortDirections() for Wind class
* fixed: current wind motion dancing around target value 

## 4.3.20.1
* fixed: server crash with NoClassDefFoundError: com.endertech.minecraft.forge.configs.ForgeKeys

## 4.3.20.0
+ added: durability bounds const
+ added: method to join arrays 
+ added: AxisAlignedBB helper class
* fixed: ForgeTileEntity.shouldRefresh method

## 4.3.19.0
+ added: IUnitWithMeshDefinition interface
+ added: GlassMeter abstract class
* improved: UnitVariant class to match forge blockstate format

## 4.3.18.0
+ added: config option to remove repair penalty for breakable items
* fixed: getting incorrect variants from ModelResourceLocation
* fixed: incorrect caching for ModelResourceLocation

## 4.3.17.0
+ added: Multi-config String property
+ added: Multi-config UnitId property

## 4.3.16.0
+ added: predefined signature for NonNullList.get method
+ added: LadderShapedCharge abstract class for shaped explosions
+ added: WorldBounds class for working with 3d bounds
+ added: IEmitter interface
* implemented: IntBounds class as Iterable
* improved: IBounds<T> interface

## 4.3.15.0
* extended: IPollutant interface for better performance

## 4.3.14.0
+ added: new methods to IPollutant interface
+ added: new predefined method descriptors

## 4.3.13.0
+ implemented: asynchronous timers for periodic updates and better performance

## 4.3.12.0
+ added: "enabled" option for all biome configs to prevent overriding default parameters
+ added: "debug" option to the main config
* moved: most of the info messages to the debug level to reduce console spam

## 4.3.11.0
+ added: MultiConfigProperty class
* improved: ForgeMaterial class
* fixed: inability to repair armor and tools with ingots

## 4.3.10.0
+ added: config parameter for defining repair material on an anvil for all damageable items
* made: lots of refactoring

## 4.3.9.0
+ added: LavaTouchesWater hook
+ added: CustomArmorModel class
+ added: ChestWearItem class
+ added: Percentage class

## 4.3.8.0
+ added: config option to completely remove disabled units (thanks to Ilvrak) 

## 4.3.7.0
+ added: scheduled explosions
* fixed: registration of recipes for disabled units (thanks to Ilvrak)

## 4.3.6.1
* fixed: server crash on startup with NoClassDefFoundError (thanks to DeltaWolf7)

## 4.3.6.0
+ added: mod config GUI
+ added: maxVentPipeLength config option
+ added: invertedPumpState config option
+ added: ventInhaleDistance config option
* improved: GUI controls (input boxes for integer values replaced with sliders)

## 4.3.5.0
+ added: IPollutant interface
* made: lots of refactoring
* moved: ISmokeContainer interface to api package
* improved: BlockChain class implementations
* fixed: Position.getAroundCube() method

## 4.3.4.0
+ added: RelativeUnit abstract class
+ added: IRespirator interface
+ added: ModConfigGUI class
+ added: a bunch of new bytecode operations
+ implemented: VentDuct class for vent systems
* made: lots of refactoring
* improved: initialization classes for relative units
* improved: ModConfig class

## 4.3.3.0
+ added: NBT compound methods for working with string arrays
+ added: predefined signatures for ItemStack.shrink and ItemStack.splitStack methods
+ implemented: hashCode and equals methods of IntBounds and FloatBounds classes
* improved: config system for biomes
* fixed: beach biome name 
* fixed: disabled units not being registered instead of hiding from creative tabs

## 4.3.2.0
+ added: BlockCaughtFire hook

## 4.3.1.0
+ added: ShapedCharge abstract class
+ added: invertStackValue asm instruction
+ implemented: smoke outlets searching algorithm
* improved: explosives
* improved: rails
* improved: lots of refactoring
* fixed: normal names being used when invoking obfuscated methods
* fixed: shapeless recipe validating
* fixed: improper processing of ore dictionary names in crafting recipes

## 4.3.0.0
+ added: shared code to recognize chimneys and conductors
+ added: reader and writer for enum fields in network packets
+ added: Connection class for simple network messaging
+ added: new super classes for explosives, potions and consumable items
+ added: methods for saving time intervals in configs
* improved: IBounds interface and its implementations
* restructured: item and block super classes
* fixed: item configs not being saved on initialization
* fixed: field cache not working in ForgeNetMsg class

## 4.2.0.1
* fixed: wind synchronization on clients

## 4.2.0.0
+ implemented: global wind simulation with configs for each biome
+ implemented: reading obfuscated names from notch-mcp.srg
* improved: class transformers

## 4.1.0.0
* reworked: class transformers
* reworked: network messages and handlers
* updated to recommended forge-1.12.2-14.23.0.2491

## 4.0.0.0
* ported to Minecraft 1.12.1
* updated all srgs

## 3.0.2.0
* improved: threading classes

## 3.0.1.0
* improved: all network messages are synchronized with a main thread

## 3.0.0.0
* ported to Minecraft 1.12

## 2.2.0.0
* improved: asm hooks and class transformers